Index: trunk/src/VBox/Frontends/VirtualBox4/src/VBoxGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/src/VBoxGlobal.cpp	(revision 15619)
+++ trunk/src/VBox/Frontends/VirtualBox4/src/VBoxGlobal.cpp	(revision 15621)
@@ -2078,16 +2078,14 @@
     static const char *sSectionHrefTpl =
         "<tr><td width=22 rowspan=%1 align=left><img src='%2'></td>"
-            "<td colspan=3><b><a href='%3'><nobr>%4</nobr></a></b></td></tr>"
+            "<td colspan=2><b><a href='%3'><nobr>%4</nobr></a></b></td></tr>"
             "%5"
-        "<tr><td colspan=3><font size=1>&nbsp;</font></td></tr>";
+        "<tr><td colspan=2><font size=1>&nbsp;</font></td></tr>";
     static const char *sSectionBoldTpl =
         "<tr><td width=22 rowspan=%1 align=left><img src='%2'></td>"
-            "<td colspan=3><!-- %3 --><b><nobr>%4</nobr></b></td></tr>"
+            "<td colspan=2><!-- %3 --><b><nobr>%4</nobr></b></td></tr>"
             "%5"
-        "<tr><td colspan=3><font size=1>&nbsp;</font></td></tr>";
-    static const char *sSectionItemTpl1 =
-        "<tr><td width=40%><nobr><i>%1</i></nobr></td><td/><td/></tr>";
-    static const char *sSectionItemTpl2 =
-        "<tr><td width=40%><nobr>%1:</nobr></td><td/><td>%2</td></tr>";
+        "<tr><td colspan=2><font size=1>&nbsp;</font></td></tr>";
+    static const char *sSectionItemTpl =
+        "<tr><td width=40%><nobr>%1</nobr></td><td>%2</td></tr>";
 
     static QString sGeneralBasicHrefTpl, sGeneralBasicBoldTpl;
@@ -2101,8 +2099,8 @@
 
         QString generalItems
-            = QString (sSectionItemTpl2).arg (tr ("Name", "details report"), "%1")
-            + QString (sSectionItemTpl2).arg (tr ("OS Type", "details report"), "%2")
-            + QString (sSectionItemTpl2).arg (tr ("Base Memory", "details report"),
-                                              tr ("<nobr>%3 MB</nobr>", "details report"));
+            = QString (sSectionItemTpl).arg (tr ("Name", "details report"), "%1")
+            + QString (sSectionItemTpl).arg (tr ("OS Type", "details report"), "%2")
+            + QString (sSectionItemTpl).arg (tr ("Base Memory", "details report"),
+                                             tr ("<nobr>%3 MB</nobr>", "details report"));
         sGeneralBasicHrefTpl = QString (sSectionHrefTpl)
                 .arg (2 + 3) /* rows */
@@ -2119,12 +2117,12 @@
 
         generalItems
-           += QString (sSectionItemTpl2).arg (tr ("Video Memory", "details report"),
-                                              tr ("<nobr>%4 MB</nobr>", "details report"))
-            + QString (sSectionItemTpl2).arg (tr ("Boot Order", "details report"), "%5")
-            + QString (sSectionItemTpl2).arg (tr ("ACPI", "details report"), "%6")
-            + QString (sSectionItemTpl2).arg (tr ("IO APIC", "details report"), "%7")
-            + QString (sSectionItemTpl2).arg (tr ("VT-x/AMD-V", "details report"), "%8")
-            + QString (sSectionItemTpl2).arg (tr ("PAE/NX", "details report"), "%9")
-            + QString (sSectionItemTpl2).arg (tr ("3D Acceleration", "details report"), "%10");
+           += QString (sSectionItemTpl).arg (tr ("Video Memory", "details report"),
+                                             tr ("<nobr>%4 MB</nobr>", "details report"))
+            + QString (sSectionItemTpl).arg (tr ("Boot Order", "details report"), "%5")
+            + QString (sSectionItemTpl).arg (tr ("ACPI", "details report"), "%6")
+            + QString (sSectionItemTpl).arg (tr ("IO APIC", "details report"), "%7")
+            + QString (sSectionItemTpl).arg (tr ("VT-x/AMD-V", "details report"), "%8")
+            + QString (sSectionItemTpl).arg (tr ("PAE/NX", "details report"), "%9")
+            + QString (sSectionItemTpl).arg (tr ("3D Acceleration", "details report"), "%10");
 
         sGeneralFullHrefTpl = QString (sSectionHrefTpl)
@@ -2165,5 +2163,5 @@
                 LONG channel = hda.GetChannel();
                 LONG device = hda.GetDevice();
-                hardDisks += QString (sSectionItemTpl2)
+                hardDisks += QString (sSectionItemTpl)
                     .arg (toFullString (bus, channel, device))
                     .arg (details (hd, aIsNewVM));
@@ -2174,6 +2172,6 @@
         if (hardDisks.isNull())
         {
-            hardDisks = QString (sSectionItemTpl1)
-                .arg (tr ("Not Attached", "details report (HDDs)"));
+            hardDisks = QString (sSectionItemTpl)
+                .arg (tr ("Not Attached", "details report (HDDs)")).arg ("");
             ++ rows;
         }
@@ -2270,16 +2268,15 @@
         /* DVD */
         CDVDDrive dvd = aMachine.GetDVDDrive();
+        item = QString (sSectionItemTpl);
         switch (dvd.GetState())
         {
             case KDriveState_NotMounted:
-                item = QString (sSectionItemTpl1)
-                    .arg (tr ("Not mounted", "details report (DVD)"));
+                item = item.arg (tr ("Not mounted", "details report (DVD)"), "");
                 break;
             case KDriveState_ImageMounted:
             {
                 CDVDImage2 img = dvd.GetImage();
-                item = QString (sSectionItemTpl2)
-                    .arg (tr ("Image", "details report (DVD)"),
-                          locationForHTML (img.GetName()));
+                item = item.arg (tr ("Image", "details report (DVD)"),
+                                 locationForHTML (img.GetName()));
                 break;
             }
@@ -2292,7 +2289,6 @@
                     drvName :
                     QString ("%1 (%2)").arg (description, drvName);
-                item = QString (sSectionItemTpl2)
-                    .arg (tr ("Host Drive", "details report (DVD)"),
-                          fullName);
+                item = item.arg (tr ("Host Drive", "details report (DVD)"),
+                                 fullName);
                 break;
             }
@@ -2309,16 +2305,15 @@
         /* Floppy */
         CFloppyDrive floppy = aMachine.GetFloppyDrive();
+        item = QString (sSectionItemTpl);
         switch (floppy.GetState())
         {
             case KDriveState_NotMounted:
-                item = QString (sSectionItemTpl1)
-                    .arg (tr ("Not mounted", "details report (floppy)"));
+                item = item.arg (tr ("Not mounted", "details report (floppy)"), "");
                 break;
             case KDriveState_ImageMounted:
             {
                 CFloppyImage2 img = floppy.GetImage();
-                item = QString (sSectionItemTpl2)
-                    .arg (tr ("Image", "details report (floppy)"),
-                          locationForHTML (img.GetName()));
+                item = item.arg (tr ("Image", "details report (floppy)"),
+                                 locationForHTML (img.GetName()));
                 break;
             }
@@ -2331,7 +2326,6 @@
                     drvName :
                     QString ("%1 (%2)").arg (description, drvName);
-                item = QString (sSectionItemTpl2)
-                    .arg (tr ("Host Drive", "details report (floppy)"),
-                          fullName);
+                item = item.arg (tr ("Host Drive", "details report (floppy)"),
+                                 fullName);
                 break;
             }
@@ -2351,13 +2345,13 @@
             int rows = audio.GetEnabled() ? 3 : 2;
             if (audio.GetEnabled())
-                item = QString (sSectionItemTpl2)
+                item = QString (sSectionItemTpl)
                        .arg (tr ("Host Driver", "details report (audio)"),
                              toString (audio.GetAudioDriver())) +
-                       QString (sSectionItemTpl2)
+                       QString (sSectionItemTpl)
                        .arg (tr ("Controller", "details report (audio)"),
                              toString (audio.GetAudioController()));
             else
-                item = QString (sSectionItemTpl1)
-                    .arg (tr ("Disabled", "details report (audio)"));
+                item = QString (sSectionItemTpl)
+                    .arg (tr ("Disabled", "details report (audio)"), "");
 
             detailsReport += sectionTpl
@@ -2393,5 +2387,5 @@
                         attType = attType.arg (vboxGlobal().toString (type));
 
-                    item += QString (sSectionItemTpl2)
+                    item += QString (sSectionItemTpl)
                         .arg (tr ("Adapter %1", "details report (network)")
                               .arg (adapter.GetSlot() + 1))
@@ -2402,6 +2396,6 @@
             if (item.isNull())
             {
-                item = QString (sSectionItemTpl1)
-                    .arg (tr ("Disabled", "details report (network)"));
+                item = QString (sSectionItemTpl)
+                    .arg (tr ("Disabled", "details report (network)"), "");
                 ++ rows;
             }
@@ -2435,5 +2429,5 @@
                         data += toString (mode);
 
-                    item += QString (sSectionItemTpl2)
+                    item += QString (sSectionItemTpl)
                         .arg (tr ("Port %1", "details report (serial ports)")
                               .arg (port.GetSlot() + 1))
@@ -2444,6 +2438,6 @@
             if (item.isNull())
             {
-                item = QString (sSectionItemTpl1)
-                    .arg (tr ("Disabled", "details report (serial ports)"));
+                item = QString (sSectionItemTpl)
+                    .arg (tr ("Disabled", "details report (serial ports)"), "");
                 ++ rows;
             }
@@ -2471,5 +2465,5 @@
                         .arg (QDir::toNativeSeparators (port.GetPath()));
 
-                    item += QString (sSectionItemTpl2)
+                    item += QString (sSectionItemTpl)
                         .arg (tr ("Port %1", "details report (parallel ports)")
                               .arg (port.GetSlot() + 1))
@@ -2480,6 +2474,6 @@
             if (item.isNull())
             {
-                item = QString (sSectionItemTpl1)
-                    .arg (tr ("Disabled", "details report (parallel ports)"));
+                item = QString (sSectionItemTpl)
+                    .arg (tr ("Disabled", "details report (parallel ports)"), "");
                 ++ rows;
             }
@@ -2509,5 +2503,5 @@
                             active ++;
 
-                    item = QString (sSectionItemTpl2)
+                    item = QString (sSectionItemTpl)
                         .arg (tr ("Device Filters", "details report (USB)"),
                               tr ("%1 (%2 active)", "details report (USB)")
@@ -2515,6 +2509,6 @@
                 }
                 else
-                    item = QString (sSectionItemTpl1)
-                        .arg (tr ("Disabled", "details report (USB)"));
+                    item = QString (sSectionItemTpl)
+                        .arg (tr ("Disabled", "details report (USB)"), "");
 
                 detailsReport += sectionTpl
@@ -2531,11 +2525,12 @@
             if (count > 0)
             {
-                item = QString (sSectionItemTpl2)
-                    .arg (tr ("Shared Folders", "details report (shared folders)"))
-                    .arg (count);
+                item = QString (sSectionItemTpl)
+                    .arg (tr ("Shared Folders", "details report (shared folders)"),
+                          tr ("%1", "details report (shadef folders)")
+                              .arg (count));
             }
             else
-                item = QString (sSectionItemTpl1)
-                    .arg (tr ("None", "details report (shared folders)"));
+                item = QString (sSectionItemTpl)
+                    .arg (tr ("None", "details report (shared folders)"), "");
 
             detailsReport += sectionTpl
@@ -2554,10 +2549,11 @@
 
                 if (srv.GetEnabled())
-                    item = QString (sSectionItemTpl2)
-                        .arg (tr ("VRDP Server Port", "details report (VRDP)"))
-                        .arg (srv.GetPort());
+                    item = QString (sSectionItemTpl)
+                        .arg (tr ("VRDP Server Port", "details report (VRDP)"),
+                              tr ("%1", "details report (VRDP)")
+                                  .arg (srv.GetPort()));
                 else
-                    item = QString (sSectionItemTpl1)
-                        .arg (tr ("Disabled", "details report (VRDP)"));
+                    item = QString (sSectionItemTpl)
+                        .arg (tr ("Disabled", "details report (VRDP)"), "");
 
                 detailsReport += sectionTpl