Index: trunk/src/VBox/Frontends/VirtualBox4/nls/VirtualBox_fr.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/nls/VirtualBox_fr.ts	(revision 15712)
+++ trunk/src/VBox/Frontends/VirtualBox4/nls/VirtualBox_fr.ts	(revision 15713)
@@ -2514,5 +2514,5 @@
         <source>&lt;br&gt;&lt;nobr&gt;Type&amp;nbsp;(Format):&amp;nbsp;&amp;nbsp;%2&amp;nbsp;(%3)&lt;/nobr&gt;</source>
         <comment>hard disk</comment>
-        <translation>&lt;br&gt;&lt;nobr&gt;Type&amp;nbsp;(Format)&amp;nbsp:&amp;nbsp;&amp;nbsp;%2&amp;nbsp;(%3)&lt;/nobr&gt;</translation>
+        <translation>&lt;br&gt;&lt;nobr&gt;Type&amp;nbsp;(Format)&amp;nbsp;:&amp;nbsp;&amp;nbsp;%2&amp;nbsp;(%3)&lt;/nobr&gt;</translation>
     </message>
     <message>
@@ -4397,5 +4397,5 @@
         <location filename="../src/VBoxSelectorWnd.cpp" line="1278"/>
         <source>Configure the selected virtual machine</source>
-        <translation>Configure la machine virtuelle sélectionnée</translation>
+        <translation>Configurer la machine virtuelle sélectionnée</translation>
     </message>
     <message>
@@ -4690,5 +4690,5 @@
         <location filename="../src/VBoxSnapshotsWgt.cpp" line="687"/>
         <source>Discard the selected snapshot of the virtual machine</source>
-        <translation>Rejeter l&apos;instantané choisis de la machine virtuelle</translation>
+        <translation>Rejeter l&apos;instantané choisi de la machine virtuelle</translation>
     </message>
     <message>
@@ -4710,5 +4710,5 @@
         <location filename="../src/VBoxSnapshotsWgt.cpp" line="690"/>
         <source>Discard the current snapshot and revert the machine to the state it had before the snapshot was taken</source>
-        <translation>Rejeter l&apos;instantané actuel et remettre l&apos;état de la machine sur celui qu&apos;elle avait avant ls saisie de l&apos;instantané</translation>
+        <translation>Rejeter l&apos;instantané actuel et remettre l&apos;état de la machine sur celui qu&apos;elle avait avant la saisie de l&apos;instantané</translation>
     </message>
     <message>
@@ -4925,5 +4925,5 @@
         <location filename="../src/VBoxSelectorWnd.cpp" line="323"/>
         <source>No description. Press the Edit button below to add it.</source>
-        <translation>Pas de description. Cliquer le bouton Editer pour ajouter une description.</translation>
+        <translation>Pas de description. Cliquer sur le bouton Editer pour ajouter une description.</translation>
     </message>
     <message>
@@ -5719,5 +5719,5 @@
         <location filename="../ui/VBoxVMSettingsGeneral.ui" line="645"/>
         <source>When checked, the virtual machine will support the Advanced Configuration and Power Management Interface (ACPI). &lt;b&gt;Note:&lt;/b&gt; don&apos;t disable this feature after having installed a Windows guest operating system!</source>
-        <translation>Si cette fonction est cochée, la machine virtuelle supportera l&apos;interface avancée de gestion et de configuration de l&apos;énergie (ACPI). &lt;b&gt;Note&amp;nbsp;: &lt;/b&gt; ne désactivez pas ceci après l&apos;installation d&apos;un système d&apos;exploitation Windows:</translation>
+        <translation>Si cette fonction est cochée, la machine virtuelle supportera l&apos;interface avancée de gestion et de configuration de l&apos;énergie (ACPI). &lt;b&gt;Note&amp;nbsp;: &lt;/b&gt; ne désactivez pas ceci après l&apos;installation d&apos;un système d&apos;exploitation Windows!</translation>
     </message>
     <message>
@@ -5729,5 +5729,5 @@
         <location filename="../ui/VBoxVMSettingsGeneral.ui" line="661"/>
         <source>When checked, the virtual machine will support the Input Output APIC (IO APIC), which may slightly decrease the VM performance. &lt;b&gt;Note:&lt;/b&gt; don&apos;t disable this feature after having installed a Windows guest operating system!</source>
-        <translation>Si cette fonction est cochée, la machine virtuelle supportera l&apos;APIC entrée/sortie (IO-APIC), ce qui peut légèrement diminuer la performance de la VM. &lt;b&gt;Note&amp;nbsp;: &lt;/b&gt; ne désactivez pas ce paramètre après l&apos;installation d&apos;un système d&apos;exploitation Windows:</translation>
+        <translation>Si cette fonction est cochée, la machine virtuelle supportera l&apos;APIC entrée/sortie (IO-APIC), ce qui peut légèrement diminuer la performance de la VM. &lt;b&gt;Note&amp;nbsp;: &lt;/b&gt; ne désactivez pas ce paramètre après l&apos;installation d&apos;un système d&apos;exploitation Windows!</translation>
     </message>
     <message>